//=============================================================================
// ActionList.cpp
//=============================================================================
#include "Stdinc.h"
#include <algorithm>
#include "ActionList.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CActionList::CActionList(void)
	:m_nFrameCount( 0 ), m_bActing( FALSE ), m_nWaitFrame( 0 )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CActionList::~CActionList(void)
{
	RemoveAllAction();
}

//-----------------------------------------------------------------------------
// RemoveAllAction
//-----------------------------------------------------------------------------
void CActionList::RemoveAllAction( void )
{
	using namespace std;

	// v[ANVXg
	vector<TIMEKEEP_INFO *>::iterator it = m_lstPlayerAction.begin();
	while( it != m_lstPlayerAction.end() )
	{
		if ( !(*it) )
		{
			++it;
			continue;
		}
		delete (*it);
		(*it) = NULL;

		++it;
	}
	m_lstPlayerAction.clear();

	// GANVXg
	vector<TIMEKEEP_INFO *>::iterator it2 = m_lstEnemyAction.begin();
	while( it2 != m_lstEnemyAction.end() )
	{
		if ( !(*it2) )
		{
			++it2;
			continue;
		}
		delete (*it2);
		(*it2) = NULL;

		++it2;
	}
	m_lstEnemyAction.clear();
	
}
//-----------------------------------------------------------------------------
// Initialize
//-----------------------------------------------------------------------------
BOOL CActionList::Initialize( void )
{
	m_nFrameCount = 0;
	m_bActing = FALSE;
	RemoveAllAction();

	return TRUE;
}
//-----------------------------------------------------------------------------
// Finalize
//-----------------------------------------------------------------------------
void CActionList::Finalize( void )
{
	RemoveAllAction();
}
//-----------------------------------------------------------------------------
// Finalize
//-----------------------------------------------------------------------------
void CActionList::FrameMove( void )
{
	m_nFrameCount ++;

	if ( 0 < m_nWaitFrame )
	{
		m_nWaitFrame --;
		if ( m_nWaitFrame == 0 )
		{
			m_bActing = FALSE;
			LOG_OUTPUT("SetSomeoneActing [%d]\n", m_bActing );
		}
	}
}
//-----------------------------------------------------------------------------
// Add
//-----------------------------------------------------------------------------
void CActionList::Add( int nType,TIMEKEEP_INFO *pInfo )
{
	pInfo->nAddFrame  = m_nFrameCount;

	if ( nType == ACT_PLAYER )
		m_lstPlayerAction.push_back( pInfo );
	else
		m_lstEnemyAction.push_back( pInfo );

	Sort();
}
//-----------------------------------------------------------------------------
// ActionCompFunc
//-----------------------------------------------------------------------------
static BOOL ActionCompFunc( TIMEKEEP_INFO *pItemLhs, TIMEKEEP_INFO *pItemRhs )
{
	return ( pItemLhs->nAddFrame + pItemLhs->nExecWaitFrame ) > ( pItemRhs->nAddFrame + pItemRhs->nExecWaitFrame );
}

//-----------------------------------------------------------------------------
// Sort
//-----------------------------------------------------------------------------
void CActionList::Sort( void )
{
	// ԏɃ\[g
	std::sort( m_lstPlayerAction.begin(), m_lstPlayerAction.end(), ActionCompFunc );
	std::sort( m_lstEnemyAction.begin(), m_lstEnemyAction.end(), ActionCompFunc );

	//CSysDebug::printActionList( m_lstPlayerAction );
	//CSysDebug::printActionList( m_lstEnemyAction );
}


//-----------------------------------------------------------------------------
// PopAction
//-----------------------------------------------------------------------------
TIMEKEEP_INFO *CActionList::PopAction( int nType )
{
	TIMEKEEP_INFO *pInfo;

	std::vector<TIMEKEEP_INFO *> *plstAction;

	if ( nType == ACT_PLAYER )
		plstAction = &m_lstPlayerAction;
	else
		plstAction = &m_lstEnemyAction;

	if ( plstAction->size() == 0 )
		return NULL;

	// ԋ߂ɃANVN̂`FbN
	pInfo = plstAction->back();

	if ( pInfo->nAddFrame + pInfo->nExecWaitFrame <= m_nFrameCount )
	{
		plstAction->pop_back();

		//CSysDebug::printActionList( *plstAction );

		return pInfo;
	}

	// ׂANV͂Ȃ
	return NULL;
}
//-----------------------------------------------------------------------------
// PopAction
//-----------------------------------------------------------------------------
void CActionList::SetSomeoneActing( BOOL bFlag )
{	
	if ( !bFlag )
	{
		m_nWaitFrame = 60;
		return;
	}

	m_bActing = bFlag;
	LOG_OUTPUT("SetSomeoneActing [%d]\n", m_bActing );
};