//=============================================================================
// CharacterObject.h
//=============================================================================
#include "Drawable.h"
#pragma once

//-----------------------------------------------------------------------------
// CCharacterObject
//-----------------------------------------------------------------------------
class CCharacterObject : public CDrawable
{
public:

	enum {	// l^
		STATE_WALK_1 = 0,	// s1
		STATE_STAND_1,		// 
		STATE_WALK_2,		// s2
		STATE_STAND_2,		// 
		STATE_MAX
	};

	enum{
		PIC_COUNT = DIRECTION_MAX * STATE_MAX,
		INVALID_ID = 0,
	};

	enum {	// zu^
		STATE_1 = 0,		// 1
		STATE_2,			// 2
	};

protected:
	int		m_nID;					// ID
	int		m_nPicID;				// 摜ID
	int		m_nDirection;			// 
	int		m_nState;				// Xe[^X
	int		m_nHandle[PIC_COUNT];	// G
	int		m_nMoveFrameCnt;		// ړt[JE^
	int		m_nStartFrameCnt;		// ړJnt[JE^

	int		m_nLastUseLeg;			// OsɎg ( STATE_WALK_1 or STATE_WALK_2 )

	BOOL Load( int nPicID );		// [h

public:
	CCharacterObject(void);
	virtual ~CCharacterObject(void);

	BOOL Create( int nID, int nPicID );	// 
	void FrameMove( void );				// XV
	void Render( void );				// `

	void Delete( void );				// j

	int GetID( void ) const
	{	return m_nID;	};

	void SetState( int nState )			// Xe[gݒ
	{	m_nState = nState;	};

	int CalcState( int nScrollOffset, int nX, int nY );

	void SetPosTile( int nX, int nY, int nDirection );	// ʒu
	
	void SetDirection( int nDirection )	// 
	{	m_nDirection = nDirection;	};
	int GetDirection( void )
	{	return m_nDirection;	};
};

