//=============================================================================
// DataManager.h
//=============================================================================
#pragma once
#include <map>
#include <vector>

class CMapManager;
class CMapEvent;
class CMapObject;
class CItem;
class CEquipItem;
class CEnemy;
//-----------------------------------------------------------------------------
// CDataManager
//-----------------------------------------------------------------------------
class CDataManager
{
private:
	CDataManager(void);
	virtual ~CDataManager(void);

	BOOL	m_bLoadedMapChipGraph;
	BOOL	m_bLoadedCharacterGraph;
	BOOL	m_bLoadedFrameWndGraph;

public:
	// ANZXȈՉ
	int		m_nHandleMapChip[MAP_CHIP_GRAPH_MAX];
	int		m_nHandleCharacter[CHAR_GRAPH_MAX];
	int		m_nHandleFrameWnd[FRAME_CHIP_COUNT];	// t[EBhE摜nh

	int		m_nAniGraphHandle[MAX_ANIMATION_CHIP][CHIP_ANIMATION_FRAME];


	void GetMapObjectLocation( int *pX, int *pY, int nEventID, const CMapEvent *pMapEvent );

	const char *GetCharName( int nPlayerCharID ) const;

	// ITEM CSV
	BOOL LoadOneNormalItemDataCSV( int nItemID, CItem *pItem );
	BOOL LoadOneEquipItemDataCSV( int nItemID, CEquipItem *pItem );

	// LvInfo CSV
	BOOL LoadLvInfoDataCSV( int nPlayerCharID, int nLv, BASE_PARAM *pBaseParam );
	// Lv܂
	int GetToNextLvCSV( int nPlayerCharID, int nLv, int nExp );

	BOOL CreateAnimationChipGraph( std::map<int, int> &mapInfo );
public:
	static CDataManager *GetInstance( void );

	// }bv`bv Ǎ/폜
	BOOL LoadMapChipGraph( std::map<int, int> &mapInfo );
	void DeleteMapChipGraph( void );

	// }bvǂݍ
	BOOL LoadMap( int nMapID, CMapManager *pMap );

	// LN^GǍ
	BOOL LoadCharacterGraph( void );
	void DeleteCharacterGraph( void );

	// ACef[^ǂݍ
	BOOL LoadOneItemData( int nItemID, CItem **pItem );

	// t[EBhEG 쐬/폜
	BOOL LoadFrameWndGraph( void );
	void DeleteFrameWndGraph( void );

	// t[EBhEG擾
	void GetFrameWndGraph( int *pHandle )
	{	CopyMemory( pHandle, m_nHandleFrameWnd, sizeof(m_nHandleFrameWnd) );	};

	//  Wu֘A
	// ToDo : ̃NXɉu
	const char *GetJobName( int nID );

	//  R}h֘A
	// ToDo : ̃NXɉu
	const char *GetCommandText( int nID );

	//  @֘A
	// ToDo : ̃NXɉu
	const char *GetMagicName( int nID );

	// Gp[eBe[uǂݍ
	BOOL LoadEnemyParty( int nPartyID, std::vector<CEnemy *> &lstEnemy );

};

typedef struct {
	int		nMapID;						// }bvID
	BOOL	bLoopAtEdge;				// [Ń[v邩
	int		nChipID[LAYER_CHIP_MAX];	// Ή}bv`bvID
}MapDataInfo;
