//=============================================================================
// EquipItemListWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "EquipItemListWindow.h"
#include "PlayerParty.h"
#include "EquipWindow.h"
#include "Manipulator.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEquipItemListWindow::CEquipItemListWindow(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEquipItemListWindow::~CEquipItemListWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CEquipItemListWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CEquipWindow *pParent )
{
	BOOL bRet = CListWindow::Create( iPosX, iPosY, iWidth, iHeight );

	m_pParent = pParent;
	m_pPlayerParty = pParty;

	return bRet;
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CEquipItemListWindow::Render( void )
{

	CListWindow::Render();

	for ( int iCnt = 0; iCnt < (int)m_aryItem.size(); iCnt ++ )
	{
		DWORD dwColor;
		stMenuItem *pItem = m_aryItem.at( iCnt );
		if ( pItem->bEnabled )
		{
			dwColor = STRING_COLOR;
		}
		else
		{
			dwColor = DISABLED_STRING_COLOR;
		}
		// ACRE
		DrawString( m_nPosX + pItem->nPosX + 8, m_nPosY + pItem->nPosY, pItem->lpzText, dwColor );
	}

	// J[\`
	if ( m_bFocused  )
	{
		m_pCursor->Render();
	}
}

//-----------------------------------------------------------------------------
// UpdateDispItem
// \ACeXV
//-----------------------------------------------------------------------------
void CEquipItemListWindow::UpdateDispItem( void )
{
	ClearMenuItem();

	CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( m_pParent->GetSelectedPlayerIndex() );
	if ( !pPlayer )
		return;

	// YLɑł̂XgAbv
	int nKindCount = m_pPlayerParty->GetEquipableItemList( pPlayer->m_CharInfo.nJobID, m_pParent->GetSelectedCharPos(), m_lstItemInfo );

	// _~[ACeǉ
	const int BASE_POS_X  =  30;
	const int BASE_POS_Y  =  10;
	const int INCREMENT_Y =  15;
	for ( int iCnt = 0; iCnt < nKindCount - m_nTopItemIndex; iCnt ++ )
	{
		stMenuItem Item;
		Item.nID = iCnt;
		Item.bEnabled = TRUE;

		// ʒu
		Item.nPosX = BASE_POS_X;
		Item.nPosY = INCREMENT_Y * iCnt + BASE_POS_Y;
		Item.lpzText = m_lstItemInfo.at(m_nTopItemIndex + iCnt)->pItem->szName;
		Item.nIcon = 0;
		Item.nCount = 0;

		AddMenuItem( &Item );
	}

	// ToDo : 1y[Wɂ܂Ȃ̏
	m_nMaxItemCount = m_nPageItemCount = nKindCount;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CEquipItemListWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	int nLastTopItemIndex = m_nTopItemIndex;

	CListWindow::FrameMove( pMani );

	
	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		m_pParent->NotifyDecideKey( this, m_nTopItemIndex + GetCurPos() );
	}

	if ( m_nTopItemIndex != nLastTopItemIndex )
	{	// XN[Ă\ACeXV
		UpdateDispItem();
	}
}
//-----------------------------------------------------------------------------
// GetSelectedItem
//-----------------------------------------------------------------------------
CEquipItem *CEquipItemListWindow::GetSelectedItem( void )
{
	if ( m_lstItemInfo.empty() )
		return NULL;

	int nIndex = m_nTopItemIndex + m_nCursorIndex;
	stItemInfo *pItem = m_lstItemInfo.at( nIndex );
	if ( !pItem )
		return NULL;

	return (CEquipItem *)pItem->pItem;
}