//=============================================================================
// EquipParamWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "EquipParamWindow.h"
#include "PlayerChar.h"
#include "PlayerParty.h"
#include "EquipWindow.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEquipParamWindow::CEquipParamWindow(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEquipParamWindow::~CEquipParamWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CEquipParamWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CEquipWindow *pParent )
{
	BOOL bRet = CFrameWindow::Create( iPosX, iPosY, iWidth, iHeight );

	m_pPlayerParty = pParty;
	m_pParent = pParent;

	return bRet;
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CEquipParamWindow::Render( void )
{
	CFrameWindow::Render();

	CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( m_pParent->GetSelectedPlayerIndex() );
	if ( !pPlayer )
		return;

	CEquipItem *pEquip = m_pParent->GetSelectedListItem();

	PARAM ParamTemp;
	pPlayer->CalcParam( &ParamTemp, pEquip, m_pParent->GetSelectedCharPos() );

	const int BASE_POS_X1 = m_nPosX + 6;
	const int BASE_POS_X2 = BASE_POS_X1 + 100;
	const int BASE_POS_X3 = BASE_POS_X2 + 32;
	const int BASE_POS_Y1 = m_nPosY + 3;

	COLORREF colEquiped = STRING_COLOR;

	char wkBuff[64];
	// 
	DrawString( BASE_POS_X1, BASE_POS_Y1 +  0, "", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.Base.nStrength );
	DrawString( BASE_POS_X2, BASE_POS_Y1 +  0, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.Base.nStrength );
		colEquiped = GetEquipedTextColor( ParamTemp.Base.nStrength, pPlayer->m_Param.Base.nStrength );
		DrawString( BASE_POS_X3, BASE_POS_Y1 +  0, wkBuff, colEquiped );
	}

	// 傭
	DrawString( BASE_POS_X1, BASE_POS_Y1 +  12, "傭", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.Base.nVitality );
	DrawString( BASE_POS_X2, BASE_POS_Y1 +  12, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.Base.nVitality );
		colEquiped = GetEquipedTextColor( ParamTemp.Base.nVitality, pPlayer->m_Param.Base.nVitality );
		DrawString( BASE_POS_X3, BASE_POS_Y1 + 12, wkBuff, colEquiped );
	}


	// ΂₳
	DrawString( BASE_POS_X1, BASE_POS_Y1 +  24, "΂₳", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.Base.nSpeed );
	DrawString( BASE_POS_X2, BASE_POS_Y1 +  24, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.Base.nSpeed );
		colEquiped = GetEquipedTextColor( ParamTemp.Base.nSpeed, pPlayer->m_Param.Base.nSpeed );
		DrawString( BASE_POS_X3, BASE_POS_Y1 + 24, wkBuff, colEquiped );
	}

	// ܂傭
	DrawString( BASE_POS_X1, BASE_POS_Y1 +  36, "܂傭", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.Base.nIntellect );
	DrawString( BASE_POS_X2, BASE_POS_Y1 +  36, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.Base.nIntellect );
		colEquiped = GetEquipedTextColor( ParamTemp.Base.nIntellect, pPlayer->m_Param.Base.nIntellect );
		DrawString( BASE_POS_X3, BASE_POS_Y1 + 36, wkBuff, colEquiped );
	}

	// 
	DrawString( BASE_POS_X1, BASE_POS_Y1 +  48, "", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.Base.nPiety );
	DrawString( BASE_POS_X2, BASE_POS_Y1 +  48, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.Base.nPiety );
		colEquiped = GetEquipedTextColor( ParamTemp.Base.nPiety, pPlayer->m_Param.Base.nPiety );
		DrawString( BASE_POS_X3, BASE_POS_Y1 + 48, wkBuff, colEquiped );
	}

	// 
	DrawString( BASE_POS_X1, BASE_POS_Y1 +  60, "", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.Base.nLuck );
	DrawString( BASE_POS_X2, BASE_POS_Y1 +  60, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.Base.nLuck );
		colEquiped = GetEquipedTextColor( ParamTemp.Base.nLuck, pPlayer->m_Param.Base.nLuck );
		DrawString( BASE_POS_X3, BASE_POS_Y1 + 60, wkBuff, colEquiped );
	}


	const int BASE_POS_Y2 = BASE_POS_Y1 + 75;
	// 
	DrawString( BASE_POS_X1, BASE_POS_Y2 +  0, "", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.nAttack );
	DrawString( BASE_POS_X2, BASE_POS_Y2 +  0, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.nAttack );
		colEquiped = GetEquipedTextColor( ParamTemp.nAttack, pPlayer->m_Param.nAttack );
		DrawString( BASE_POS_X3, BASE_POS_Y2 + 0, wkBuff, colEquiped );
	}

	// ڂ
	DrawString( BASE_POS_X1, BASE_POS_Y2 + 12, "ڂ", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.nDefence );
	DrawString( BASE_POS_X2, BASE_POS_Y2 + 12, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.nDefence );
		colEquiped = GetEquipedTextColor( ParamTemp.nDefence, pPlayer->m_Param.nDefence );
		DrawString( BASE_POS_X3, BASE_POS_Y2 + 12, wkBuff, colEquiped );
	}

	// ܂قڂ
	DrawString( BASE_POS_X1, BASE_POS_Y2 + 24, "܂قڂ", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.nMagicDef );
	DrawString( BASE_POS_X2, BASE_POS_Y2 + 24, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.nMagicDef );
		colEquiped = GetEquipedTextColor( ParamTemp.nMagicDef, pPlayer->m_Param.nMagicDef );
		DrawString( BASE_POS_X3, BASE_POS_Y2 + 24, wkBuff, colEquiped );
	}

	// Ђ
	DrawString( BASE_POS_X1, BASE_POS_Y2 + 36, "Ђ", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.nParry );
	DrawString( BASE_POS_X2, BASE_POS_Y2 + 36, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.nParry );
		colEquiped = GetEquipedTextColor( ParamTemp.nParry, pPlayer->m_Param.nParry );
		DrawString( BASE_POS_X3, BASE_POS_Y2 + 36, wkBuff, colEquiped );
	}
	DrawString( BASE_POS_X3+20, BASE_POS_Y2 + 36, "", colEquiped );

	// ܂ق
	DrawString( BASE_POS_X1, BASE_POS_Y2 + 48, "܂ق", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.nMagicPar );
	DrawString( BASE_POS_X2, BASE_POS_Y2 + 48, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.nMagicPar );
		colEquiped = GetEquipedTextColor( ParamTemp.nMagicPar, pPlayer->m_Param.nMagicPar );
		DrawString( BASE_POS_X3, BASE_POS_Y2 + 48, wkBuff, colEquiped );
	}
	DrawString( BASE_POS_X3+20, BASE_POS_Y2 + 48, "", colEquiped );

	// т̂
	DrawString( BASE_POS_X1, BASE_POS_Y2 + 60, "т̂", STRING_COLOR );
	sprintf_s( wkBuff, "%3dc", pPlayer->m_Param.nWeight );
	DrawString( BASE_POS_X2, BASE_POS_Y2 + 60, wkBuff, STRING_COLOR );
	if ( pEquip )
	{
		sprintf_s( wkBuff, "%3d", ParamTemp.nWeight );

		// yقǂFɂ
		//colEquiped = GetEquipedTextColor( ParamTemp.nWeight, pPlayer->m_Param.nWeight );
		colEquiped = GetEquipedTextColor( pPlayer->m_Param.nWeight, ParamTemp.nWeight );
		DrawString( BASE_POS_X3, BASE_POS_Y2 + 60, wkBuff, colEquiped );
	}
}
//-----------------------------------------------------------------------------
// GetEquipedTextColor
//-----------------------------------------------------------------------------
COLORREF CEquipParamWindow::GetEquipedTextColor( int nAfterVal, int nBeforeVal ) const
{
	if ( nAfterVal < nBeforeVal )
		return DISABLED_STRING_COLOR;

	else if ( nBeforeVal < nAfterVal )
		return STS_UP_STRING_COLOR;

	return STRING_COLOR;
}
