//=============================================================================
// Game.h
//=============================================================================
#pragma once
#include <list>

#include "MapManager.h"
#include "Manipulator.h"
#include "PlayerParty.h"
#include "MsgWindow.h"
#include "Effect.h"
#include "Flag.h"
#include "Cursor.h"
#include "CampWindow.h"
#include "StoreWindow.h"
#include "Battle.h"
#include "SoundManager.h"

class CDrawable;
class CMapObject;
//-----------------------------------------------------------------------------
// CGame
//-----------------------------------------------------------------------------
class CGame
{
private:
	CGame(void);
	virtual ~CGame(void);

protected:
	int				m_nMode;		// Q[[h
	int				m_nLastMode;	// ÕQ[[h
	int				m_nWaitStatus;	// ҂Ă邩

	time_t			m_timStartTime;		// Jn
	time_t			m_timLastPlayTime;	// OJn
	time_t			m_timPlayTime;		// vC

	// eǗNX
	CMapManager		m_Map;			// n}
	CBattle			m_Battle;		// 퓬
	CManipulator	m_Mani;			// 
	CSoundManager	m_Sound;		// TEh
	CPlayerParty	m_PlayerParty;	// v[
	CMsgWindow		m_wndMsg;		// bZ[WEBhE
	CEffect			m_Effect;		// GtFNg
	CFlag			m_Flag;			// Q[tOǗ
	CCursor			m_Cursor;		// J[\
	CCampWindow		m_wndCamp;		// LvEBhE
	CStoreWindow	m_wndStore;		// XEBhE

	// }bvؑ֗v
	stMapChangeReqParam		m_MapChangeReqParam;
	// }bvړv
	stMapMoveReqParam		m_MapMoveReqParam;

	// IuWFNgړv
	CMapObject				*m_pMapObjMoveReqTgt;
	// t[JE^҂v
	int						m_nWaitFrame;

	void FrameMove_ModeMap( void );
	void ChangeDirToPlayer( CMapObject *pMapObj );
	void ChangeMap( stMapChangeReqParam *pPram );
	void UpdatePlayTime( void );

	void Encount( void );
	void StartBattle( void );

	// ToDo
	void DEBUG_init( void );
	void DEBUG_SetupHPMP( CPlayerChar *pPlayer );

public:
	static CGame *GetInstance( void );
	CCursor *GetCursor( void )
	{	return &m_Cursor;	};

	BOOL Initialize( void );	// 
	void Finalize( void );		// I

	void FrameMove( void );		// XV

	void Render( void );		// `
	void RenderToTargetScreen( void );	// ^[QbgT[tF[Xɕ`

	int GetMapID( void ) const
	{	return m_Map.GetID();	};

	// Q[[h
	int GetLastMode( void )	{	return m_nLastMode;	};
	int GetMode( void )		{	return m_nMode;	};

	void SetMode( int nMode )
	{
//		LOG_OUTPUT("ModeChange %d -> %d\n", m_nMode, nMode );
		if ( m_nMode == nMode )
			return;	// [hȂ牽Ȃ

		m_nLastMode = m_nMode;
		m_nMode		= nMode;
	};
	void SetToPrevMode( void )
	{	//	LOG_OUTPUT("SetToPrevMode %d  %d\n", m_nMode, m_nLastMode );
		SetMode( m_nLastMode );	};

	// Z[u\
	BOOL CanSaveNow( void );

	// vCԎ擾
	time_t GetPlayTime( void ) const
	{	return m_timPlayTime;	};

	// 擾
	UINT GetGill( void )
	{	return m_PlayerParty.GetGill();	};

	// ҂
	int GetWaitStatus( void )
	{	return m_nWaitStatus;	};

	void SetWaitStatus( int nWaitStatus )
	{
		//LOG_OUTPUT( "WaitSts [%d] -> [%d]\n", m_nWaitStatus, nWaitStatus );
		m_nWaitStatus = nWaitStatus;	
	};

	// GtFNg
	int GetOffsetX( void ) const
	{	return m_Effect.GetShakeOffsetX();	};
	int GetOffsetY( void ) const
	{	return m_Effect.GetShakeOffsetY();	};

	// 퓬Iʒm
	void FinishedBattle( void );

	// }bv}l[WANZbT
	CMapManager *GetMapMan( void )
	{	return &m_Map;	};

	// XNvgJnv
	void StartScriptRequest( CMapObject *pMapObj );

	// LuaR[obNp
	void ShowMessage( const char *lpzMessage );
	void CloseMessage( void );
	void AddMessage( const char *lpzMessage );
	void StartFadeout( DWORD dwColor, UINT nFrame );
	void StartFadein( DWORD dwColor, UINT nFrame );
	void StartShake( int nType, UINT nFrame, double dblSpeed, int nScale );
	void ChangeMapRequest( int nMapID, int nLocX, int nLocY, int nPlayerDir );
	char GetTreasureFlag( int nMapID, int nEventID, int *pIndex = NULL );
	void GetTreasure( int nMapID, int nEventID, CItem **pItem );
	void MovePlayer( int nDirection, int nSpeed );
	void MoveMapObject( int nEventID, int nDirection, int nSpeed );
	void WaitFrame( int nFrame );
	void OpenStore( int nType, int nMsgPtn, int nRate, int nItemCount, int *pItemID );
	void LoadSoundFile( int nID );
	void PlayBGM( int nID, BOOL bTopPositionFlag );
	void StopBGM( void );

};
