//=============================================================================
// ItemEquipJobWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "ItemEquipJobWindow.h"
#include "ItemWindow.h"
#include "Item.h"
#include "DataManager.h"
#include "Manipulator.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CItemEquipJobWindow::CItemEquipJobWindow(void)
	:m_pEuip( NULL )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CItemEquipJobWindow::~CItemEquipJobWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CItemEquipJobWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CItemWindow *pParent )
{
	m_pParent = pParent;

	BOOL bRet = CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );

	return bRet;
}
//-----------------------------------------------------------------------------
// SetVisible
//-----------------------------------------------------------------------------
void CItemEquipJobWindow::SetVisible( BOOL bFlag )
{
	CMenuWindow::SetVisible( bFlag );
	if ( bFlag )
	{
		m_pCursor->SetVisible( FALSE );
	}
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CItemEquipJobWindow::FrameMove( const CManipulator *pMani )
{
	if ( !IsVisible() )
		return;
	if ( !m_bFocused )
		return;

	//CMenuWindow::FrameMove();
	CFrameWindow::FrameMove();

	if ( pMani->CheckKey( KEY_INPUT_X ) || pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyDecideKey( this, 0 );
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CItemEquipJobWindow::Render( void )
{
	if ( !IsVisible() )
		return;

	//CMenuWindow::Render();
	CFrameWindow::Render();

	if ( !m_pEuip )
		return;

	// EBhEubNAEg
	SetDrawBlendMode( DX_BLENDMODE_ALPHA, 96 );		// uh[hݒ
	DrawBox( 0, 0, CANVAS_WIDTH+1, m_nPosY+1, GetColor( 0, 0, 0) , TRUE );
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND , 255 );		// uh[h߂

	// ACe
	DrawString( m_nPosX +  24, m_nPosY + 10, m_pEuip->szName, STRING_COLOR );
	DrawString( m_nPosX + 120, m_nPosY + 10, "@тłWu", STRING_COLOR );

	// Wu`
	const int BASE_Y = 20;
	const int MARGIN_X = 100;
	for ( int iCnt = 0; iCnt < JOB_ID_MAX; iCnt ++ )
	{
		int nPosX = m_nPosX + 24 + MARGIN_X * (iCnt % 3);
		int nPosY = m_nPosY + 10 + BASE_Y + (iCnt / 3) * BASE_Y;
		DWORD dwColor;
		if ( CEquipItem::CanEquip( m_pEuip->nType, iCnt ) )
		{
			dwColor = STRING_COLOR;
		}
		else
		{
			dwColor = DISABLED_STRING_COLOR;
		}

		DrawString( nPosX , nPosY, CDataManager::GetInstance()->GetJobName( iCnt ), dwColor );
	}
}
//-----------------------------------------------------------------------------
// SetEquipItem
//-----------------------------------------------------------------------------
void CItemEquipJobWindow::SetEquipItem( CEquipItem *pEuip )
{
	m_pEuip = pEuip;
}
