//=============================================================================
// MagicListWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "MagicListWindow.h"
#include "Manipulator.h"
#include "PlayerParty.h"
#include "MagicWindow.h"
#include "DataManager.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMagicListWindow::CMagicListWindow(void)
{
	m_nPageItemCount = ONE_PAGE_ITEM_COUNT;			// 1y[W 18ACe
	CMenuWindow::m_nType = MENU_TYPE_HORIZONTAL;	// ^j[
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMagicListWindow::~CMagicListWindow(void)
{
}
//-----------------------------------------------------------------------------
// UpdateDispItem
//-----------------------------------------------------------------------------
void CMagicListWindow::UpdateDispItem( void )
{
	m_pPlayerParty->GetMagicTable( m_bMagic );

	m_pCursor->RemoveAllSelectedPos();	// S폜

	for ( int iCnt = 0; iCnt < (int)m_aryItem.size(); iCnt ++ )
	{
		int nIndex = m_nTopItemIndex + iCnt;
		const char *lpText = CDataManager::GetInstance()->GetMagicName( nIndex + 1 );


		UpdateMenuText( iCnt, TRUE, lpText, 0, 0 );
		// gps\@̓O[

	}
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CMagicListWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CPlayerParty *pParty, CMagicWindow *pParent )
{
	BOOL bRet = CListWindow::Create( iPosX, iPosY, iWidth, iHeight );

	m_pParent = pParent;
	m_pPlayerParty = pParty;

	// _~[ACeǉ
	const int BASE_POS_X1 =  30;
	const int BASE_POS_X2 = 120;
	const int BASE_POS_X3 = 210;
	const int BASE_POS_Y  =  10;
	const int INCREMENT_Y =  15;

	for ( int iCnt = 0; iCnt < ONE_PAGE_ITEM_COUNT; iCnt ++ )
	{
		stMenuItem Item;
		Item.nID = iCnt;
		Item.bEnabled = TRUE;

		// ʒu
		if ( iCnt % 3 == 0 )
			Item.nPosX = BASE_POS_X1;
		else if ( iCnt % 3 == 1 )
			Item.nPosX = BASE_POS_X2;
		else
			Item.nPosX = BASE_POS_X3;

		Item.nPosY = INCREMENT_Y * (iCnt / 2) + BASE_POS_Y;
		Item.lpzText = "ACe";
		Item.nIcon = 0;
		Item.nCount = 0;

		AddMenuItem( &Item );
	}

	return bRet;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CMagicListWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	int nLastTopItemIndex = m_nTopItemIndex;

	CListWindow::FrameMove( pMani );

	
	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	// L[
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		m_pParent->NotifyDecideKey( this, m_nTopItemIndex + GetCurPos() );
	}

	if ( m_nTopItemIndex != nLastTopItemIndex )
	{	// XN[Ă\ACeXV
		UpdateDispItem();
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CMagicListWindow::Render( void )
{
	CListWindow::Render();

	// J[\`
	if ( m_bFocused  )
	{
		m_pCursor->Render();
	}
}