//=============================================================================
// MagicMainTypeMenuWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "MagicMainTypeMenuWindow.h"
#include "MagicWindow.h"
#include "Manipulator.h"

const stMenuItem MAGIC_MAIN_MENU_ITEM[] = {
	{   CMagicMainTypeMenuWindow::MENU_ID_WHITE,	TRUE,  6,   8, "܂ق", 0, 0 },
	{   CMagicMainTypeMenuWindow::MENU_ID_BLACK,	TRUE,  6,  28, "܂ق", 0, 0 },
	{   CMagicMainTypeMenuWindow::MENU_ID_SPACETIME,TRUE,  6,  48, "", 0, 0 },

};
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMagicMainTypeMenuWindow::CMagicMainTypeMenuWindow(void)
{
	m_nType = MENU_TYPE_VERTICAL;	// c^j[
	m_bLoopAtEdge = FALSE;
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMagicMainTypeMenuWindow::~CMagicMainTypeMenuWindow(void)
{
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
BOOL CMagicMainTypeMenuWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CMagicWindow *pParent )
{
	m_pParent = pParent;

	CMenuWindow::Create( iPosX, iPosY, iWidth, iHeight );


	// ACeǉ
	for ( int iCnt = 0; iCnt < sizeof( MAGIC_MAIN_MENU_ITEM ) / sizeof( MAGIC_MAIN_MENU_ITEM[0] ); iCnt ++ )
	{
		AddMenuItem( &MAGIC_MAIN_MENU_ITEM[iCnt] );
	}
	return TRUE;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CMagicMainTypeMenuWindow::FrameMove( const CManipulator *pMani )
{
	if ( !m_bFocused )
		return;

	CMenuWindow::FrameMove( pMani );

	// LZL[
	if ( pMani->CheckKey( KEY_INPUT_Z ) )
	{
		m_pParent->NotifyCancelKey( this );
	}
	else if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		m_pParent->NotifyDecideKey( this, GetCurPos() );
	}
}
