//=============================================================================
// MapManager.h
//=============================================================================
#pragma once
#include "ScriptManager.h"
#include "MapEvent.h"
#include <map>

typedef struct {
	int nID;
	int nHandle;
}stCHIP_GRAPH_INFO;

class CCharacterObject;
class CPlayer;
//-----------------------------------------------------------------------------
// CMapManager
//-----------------------------------------------------------------------------
class CMapManager
{
	friend class CDataManager;

protected:
	int			m_nID;				// \MapID
	int			m_nWidth;			// ^CPʕ
	int			m_nHeight;			// ^CPʍ

	CScriptManager	m_ScrMan;		// XNvg}l[W
	CMapEvent	m_MapEvent;			// MapCxg

	// \
	int			m_nDrawOffsetX;		// XN[`掞ItZbg
	int			m_nDrawOffsetY;
	int			m_nScrollSpeed;		// XN[Xs[h
	BOOL		m_bLoopAtEdge;		// [Ń[v邩

	std::map<int, int> m_mapChipGraphInfo;	// }bv`bvƊGhandle

	int			m_nCenterPosX;		// \S
	int			m_nCenterPosY;

	int			m_nChipID[LAYER_CHIP_MAX];	// CChipGnh
	WORD		*m_Chip[LAYER_CHIP_MAX];
	WORD		*m_wPassFlag;

	// }bv`bvG̃[h
	BOOL LoadMapChipGraph( void );

	int GetDrawPosX( int iTilePosX ) const;
	int GetDrawPosY( int iTilePosY ) const;
	int GetChipPosX( int iTileID ) const;
	int GetChipPosY( int iTileID ) const;
	int GetScrollPixel( int nScrollSpeed ) const;

	void ScrollMap( int nScrollSpeed );

	UINT	m_nFrameCnt;

public:
	CMapManager(void);
	virtual ~CMapManager(void);

	int GetID( void ) const
	{	return m_nID;	};

	BOOL Initialize( void );	// 
	void FrameMove( int nScrollSpeed );

	void Render( void );
	void RenderLayer( int nLayer );
	void RenderMapObjects( CCharacterObject *pPlayer );

	WORD **GetMapChip( void )	{	return m_Chip;	};
	WORD **GetPassFlag( void )	{	return &m_wPassFlag;	};

	// }bvIuWFNg
	CMapObject *GetMapObject( int nObjID );

	// Sʒu擾
	void GetCenterPos( int *pX, int *pY ) const
	{
		*pX = m_nCenterPosX;
		*pY = m_nCenterPosY;
	};

	// Sʒuݒ
	void SetCenterPos( int nX, int nY )
	{
		m_nCenterPosX = nX;
		m_nCenterPosY = nY;
	};
	int GetWidth( void ) const
	{	return m_nWidth;	};
	int GetHeight( void ) const
	{	return m_nHeight;	};

	// }bvbݒ
	void SetMapInfo( int nWidth, int nHeight, int *pChipID, BOOL bLoopAtEdge )
	{
		m_nWidth = nWidth;
		m_nHeight = nHeight;
		memcpy_s( m_nChipID, sizeof(m_nChipID), pChipID, sizeof(m_nChipID) );
		m_bLoopAtEdge = bLoopAtEdge;

		m_MapEvent.SetMapInfo( m_nWidth, m_nHeight );
	};

	// [h
	BOOL Load( int nID );

	BOOL BattleFinishedProc( void )
	{
		return m_ScrMan.BattleFinishedProc();
	}


	// ^C(΍W) ł̃ItZbgړ
	BOOL MoveOffsetTile( int nOffsetX, int nOffsetY );

	// ^C(΍W) ł̃qbgeXg
	WORD HitTestTile( int nX, int nY );

	// XN[擾
	BOOL IsScrolling( void ) const
	{	return m_nDrawOffsetX || m_nDrawOffsetY;	};

	BOOL IsScriptExecuting( void ) const
	{	return m_ScrMan.IsExecuting();	};

	int GetScrollOffset( void ) const
	{
		if ( m_nDrawOffsetX )
			return m_nDrawOffsetX;
		else if (m_nDrawOffsetY )
			return m_nDrawOffsetY;
		return 0;
	};
	// L[ʒm
	void NotifyDecideKey( int iDirection );

	// XNvg^[Qbg̃}bvIuWFNg擾
	CMapObject *GetTargetMapObject( void )
	{	return m_ScrMan.GetTargetMapObject();	};

	// XNvgs
	void StartExec( CMapObject *pMapObj );

	// ̃XNvgs
	void ExecNext( void );

	// v[̓Z[u|Cg̏ɂ邩
	BOOL IsPlayerOnSavePoint( void );

	// wɈړ\ǂ`FbN
	static BOOL GetNewLoc( int *pX, int *pY, int nLocX, int nLocY, int nDirection );
};
