//=============================================================================
// PlayerBattle.h
//=============================================================================
#pragma once
#include "drawable.h"
#include "NumberAnimation.h"

class CPlayerChar;
//-----------------------------------------------------------------------------
// CPlayerBattle
//-----------------------------------------------------------------------------
class CPlayerBattle : public CDrawable
{
public:
	// 퓬L`bvp^[
	enum {
		WALK_L		= 0,	// s O
		STAND		= 1,	// C
		WALK_R		= 2,	// s EO
		WAIT		= 3,	// Us҂
		ATACK_01	= 4,	// U Uグ
		ATACK_02	= 5,	// U U肨낵
		PUNCH_01	= 6,	// fU O
		PUNCH_02	= 7,	// fU ͍
		MAGIC_01	= 8,	// @r
		MAGIC_02	= 9,	// @r
		HANDS_UP	= 10,	// oUC
		DAMAGE		= 11,	// _[W
		SITDOWN		= 12,	// Ⴊ
		DEAD		= 13,	// 
		STONE		= 14,	// Ή
		BK_WALK_L	= 15,	//  s O
		BK_STAND	= 16,	//  C
		BK_WALK_R	= 17,	//  s EO
	};
	enum {
		BTL_CHAR_PTN_COUNT = 18,
	};
	enum{
		ANI_PTN_NONE = 0,			// Aj[V
		ANI_PTN_WALK_AT_START,		// Jns
		ANI_PTN_ATTACK,				// U
		ANI_PTN_ATTACK_BACK,		// U̖߂
		ANI_PTN_DAMAGE,				// _[W

		ANI_PTN_WIN_JUMP,			// 퓬̃Wv
	};
protected:
	// 퓬f[^
	CPlayerChar	*m_pPlayer;
	int			m_nID;					// ID
	int			m_nPicID;				// GID
	int			m_nState;				// Xe[^X
	int			m_nHandle[BTL_CHAR_PTN_COUNT];

	UINT		m_nAtbFrameCount;		// ATBt[JE^(CNg)

	int			m_nAnimationPtrn;		// Aj[Vp^[
	UINT		m_nAniFrameCount;		// Aj[VJE^ (fNg)

	BOOL		m_bWaitAction;

	// lAj[V
	CNumberAnimation	m_NumAnime;			// lAj[V
	void GetNumAnimeDispPos( int *pX, int *pY, int iDispWidth );

	void StopAnimation( void );
public:
	CPlayerBattle(void);
	virtual ~CPlayerBattle(void);

	int GetID( void ) const
	{	return m_nID;	};

	// 
	BOOL Create( int nID, int nPicID, CPlayerChar *pPlayer );
	void FrameMove( void );				// XV
	void Render( void );				// `

	void RenderPortrait( int nPosX, int nPosY );
	void RenderPortrait( int nPosX, int nPosY, int nState );

	// j
	void Delete( void );
	// ǂݍ
	BOOL LoadPicture( int nPicID );

	// ANVXgs҂
	void SetWaitAction( BOOL bFlag );

	BOOL IsWaitingAction( void ) const
	{	return m_bWaitAction;	};

	// ATB
	int IncreaseATBValue( int nValue );

	// Aj[VJn
	void StartAction( int nAniPtnNo );
	BOOL IsActing( void )
	{	return m_nAniFrameCount;	};

	// HPAj[VJn
	void StartNumAnimation( int iDiff, DWORD dwColor );

	// Gݒ
	void SetState( int nState )
	{	m_nState = nState;	};

	// K[h
	void SetGuard( BOOL bFlag );

};

