//=============================================================================
// PlayerChar.h
//=============================================================================
#pragma once
#include <list>
#include "characterobject.h"
#include "Item.h"
#include "PlayerBattle.h"

class CManipulator;
class CMapManager;
class CPlayerParty;
//-----------------------------------------------------------------------------
// CPlayerChar
//-----------------------------------------------------------------------------
class CPlayerChar :	public CCharacterObject
{
protected:
	CPlayerParty		*m_pParty;				// e

public:	// ANZXȈՉ
	PLAYER_CHAR_INFO	m_CharInfo;				// LN^
	BASE_PARAM			m_BasePram;				// x[Xp^
	PARAM				m_Param;				// p^
	STATUS				m_Status;				// Xe[^X

	CEquipItem			m_Equip[CHR_POS_MAX];	// i

	CPlayerBattle		m_Battle;				// 퓬p
	int					m_nCommand[PLAYER_COMMAND_MAX];


	// x[Xp^Ƒip^vZ
	void CalcParam( void );

	int GetState( int nScrollOffset, CMapManager *pMapMan );

public:
	CPlayerChar(void);
	virtual ~CPlayerChar(void);

	// 
	BOOL Create( int nID, int nPicID, CPlayerParty *pParty );

	// XV
	void FrameMove( const CManipulator *pMani, CMapManager *pMapMan );
	// L[ȂXV
	void FrameMove( CMapManager *pMapMan );

	// HP/MPS
	void RecoveryHPMP( void )
	{	m_CharInfo.nHP = m_Param.Base.nMaxHP;
		m_CharInfo.nMP = m_Param.Base.nMaxMP;};

	// Expǉ
	BOOL AddExp( int nExp );
	// ABPǉ
	BOOL AddABP( int nABP );


	// 
	BOOL SetEquipItem( CEquipItem *pEquip, int nChrPos );
	void RemoveEquipItem( int nChrPos );
	const CEquipItem *GetEquipItem( int nChrPos ) const
	{	return &m_Equip[nChrPos];	};

	BOOL IsNoWeapon( void );

	// vZ
	void CalcParam( PARAM *pParam, CEquipItem *pEquip, int nCharPos ) const;


	//  퓬pL
	// ʒu
	void SetBattlePos( int nPosX, int nPosY );

	void GetBattlePos( int *pPosX, int *pPosY )
	{	m_Battle.GetPos( pPosX, pPosY );	};

	// XV
	void FrameMoveAtBattle( void );

	// `
	void RenderAtBattle( void );

	// 폜
	void Delete( void );

	// G`
	void RenderPortrait( int nPosX, int nPosY );
	void RenderPortrait( int nPosX, int nPosY, int nState );

	// ATBlXV
	void IncreaseATBValue( void );
	// ATB|Cg폜
	void ClearATBValue( void )
	{	m_CharInfo.nAtbValue = 0;	};

	BOOL IsAtbMax( void ) const
	{	return ( ATB_VALUE_MAX <= m_CharInfo.nAtbValue );	};
		// ANVXgs҂
	void SetWaitAction( BOOL bFlag )
	{	m_Battle.SetWaitAction( bFlag );	};

	BOOL IsWaitingAction( void ) const
	{	return m_Battle.IsWaitingAction();	};

	// Ă邩
	BOOL IsAliving( void ) const
	{	return ( 0 < m_CharInfo.nHP );	};

	// R}hXg擾
	int *GetCommandList( void )
	{	return m_nCommand;	};

	// 퓬ANVJn
	void StartBattleAction( int nAniPtnNo );

	BOOL IsActing( void )
	{	return m_Battle.IsActing(); };

	// HP
	void ChangeHitPoint( int iDiff );

	// MP
	void ChangeMagicPoint( int iDiff );

	// K[h
	void SetGuard( BOOL bFlag )
	{	m_Status.bGuard = bFlag;	};
};
