//=============================================================================
// PlayerParty.h
//=============================================================================
#pragma once
#include <vector>
#include "PlayerChar.h"
#include "PlayerBattle.h"

class CManipulator;
class CMapManager;
class CItem;

//-----------------------------------------------------------------------------
// CPlayerParty
//-----------------------------------------------------------------------------
class CPlayerParty
{
protected:
	std::vector<CPlayerChar *> m_aryPlayer;			// v[L
	std::vector<stItemInfo *> m_lstItemInfo;		// ACe
	UINT			m_nGill;						// M
	BOOL			m_bMagic[MAX_MAGIC_COUNT];		// @

	// MAPړpo
	int		m_nCurrentDisp;	// ݕ\̃v[L
	BOOL	m_bIsDash;		// _bVĂ邩
	UINT	m_nAniFrameCnt;	// t[JE^


	// SACe폜
	void RemoveAllItems( void );
	// Sv[
	void RemoveAllPlayers( void );

public:
	CPlayerParty(void);
	virtual ~CPlayerParty(void);

	// 
	BOOL Initialize( void );

	// XV
	void FrameMove( const CManipulator *pMani, CMapManager *pMapMan );
	void FrameMove( CMapManager *pMapMan  );

	// `
	void Render( void  );
	void RenderPortrait( int iIndex, int nPosX, int nPosY );
	void RenderPortrait( int iIndex, int nPosX, int nPosY, int nState );

	// v[
	int AddPlayer( int nID, int nPicID );
	int RemovePlayer( int nID );
	void SwapPlayer( int nLhsID, int nRhsID );

	// ACe
	int AddItem( int nItemID );		// ǉ
	int AddItem( int nItemID, int nCount );		// wǉ
	int RemoveItem( int nItemID );	// 폜
	int RemoveItem( int nItemID, int nCount );	// w폜

	void SwapItem( int nLhsIndex, int nRhsIndex );	// ւ

	int GetItemKindCount( void ) const;		// ސ擾
	int GetItemCount( int nItemID );		// wID̃ACe擾
	int GetEquipCount( int nItemID );		// wID̑ĂACe擾
	int GetEquipableItemList( int nJobID, int nCharPos, std::vector<stItemInfo *> &lstItem );

	stItemInfo *GetItemInfoFromItemID( int nItemID );
	stItemInfo *GetItemInfo( int nIndex );

	void SortItem( void );

	// M
	UINT GetGill( void )
	{	return m_nGill;	};

	void AddGill( UINT nGill )
	{	
		m_nGill += nGill;	
		if ( MAX_GILL < m_nGill )
		{
			m_nGill = MAX_GILL;
		}
	};
	void SpendGill( UINT nGill )
	{	
		m_nGill -= nGill;
		if ( MAX_GILL < m_nGill )
		{
			m_nGill = 0;
		}
	};

	void SetDirection( int nDirection )
	{	GetFirstChar()->SetDirection( nDirection );	};

	// ݕ\v[L擾
	CPlayerChar *GetDisplayPlayer( void )
	{	return GetFirstChar();	};
	CPlayerChar *GetFirstChar( void );

	// wv[擾
	CPlayerChar *GetPlayer( int nIndex )
	{
		if ( nIndex < 0 || (int)m_aryPlayer.size() <= nIndex )
			return NULL;

		return m_aryPlayer.at(nIndex);
	}
	

	// v[擾
	int GetPlayerCount( void )
	{	return m_aryPlayer.size();	}

	// Ăv[
	int GetAlivingPlayerCount( void )
	{
		int nAliving = 0;
		for ( int iCnt = 0; iCnt < (int)m_aryPlayer.size(); iCnt ++ )
		{
			if ( m_aryPlayer.at( iCnt ) && m_aryPlayer.at( iCnt )->IsAliving() )
			{	nAliving++;		}
		}
		return nAliving;
	}

	// XN[Xs[h
	int GetScrollSpeed( void );

	// _bVĂ邩
	void SetDash( BOOL bFlag )
	{	m_bIsDash = bFlag;	};

	// 퓬pݒ
	void SetupBattlePos( void );

	// @
	void GetMagicTable( BOOL *pbMagic )
	{
		memcpy_s( pbMagic, MAX_MAGIC_COUNT, m_bMagic, sizeof(m_bMagic) );
	}
	BOOL IsGotMagic( int nMagicID )
	{
		return m_bMagic[nMagicID-1];
	}
};

