//=============================================================================
// PlayerPartyWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "PlayerPartyWindow.h"
#include "PlayerParty.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CPlayerPartyWindow::CPlayerPartyWindow(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CPlayerPartyWindow::~CPlayerPartyWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CPlayerPartyWindow::Create( int nPosX, int nPosY, int nWidth, int nHeight, CPlayerParty *pParty )
{
	m_pPlayerParty = pParty;

	BOOL bRet = CFrameWindow::Create( nPosX, nPosY, nWidth, nHeight );

	int nCounter = 0;
	for ( int iCnt = 0; iCnt < m_pPlayerParty->GetPlayerCount(); iCnt ++ )
	{
		CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer(iCnt);
		if ( !pPlayer )
			continue;

		bRet &= m_AtbGauge[iCnt].Create( m_nPosX + FRAME_TO_ATB_GAUGE_MARGINE_X, m_nPosY + FRAME_TO_NAME_MARGINE_Y + ( nCounter * (DISPLAY_MESSAGE_FONT_SIZE + 4) ) );
		m_AtbGauge[iCnt].SetValue( 0 );

		nCounter ++;
	}

	return bRet;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CPlayerPartyWindow::FrameMove( void )
{
	CFrameWindow::FrameMove();

	for ( int iCnt = 0; iCnt < m_pPlayerParty->GetPlayerCount(); iCnt ++ )
	{
		CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer(iCnt);
		if ( !pPlayer )
			continue;

		pPlayer->IncreaseATBValue();

		m_AtbGauge[iCnt].SetValue( pPlayer->m_CharInfo.nAtbValue );
		m_AtbGauge[iCnt].FrameMove();
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CPlayerPartyWindow::Render( void )
{
	CFrameWindow::Render();

	int nCounter = 0;
	for ( int iCnt = 0; iCnt < m_pPlayerParty->GetPlayerCount(); iCnt ++ )
	{
		CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer(iCnt);
		if ( !pPlayer )
			continue;

		int iPosY = m_nPosY + FRAME_TO_NAME_MARGINE_Y + ( nCounter * (DISPLAY_MESSAGE_FONT_SIZE + 4) );

		// O`
		DrawString( m_nPosX + FRAME_TO_NAME_MARGINE_X, iPosY, pPlayer->m_CharInfo.szName, STRING_COLOR );

		// HP`
		char szBuff[64];
		sprintf_s( szBuff, "%5d", pPlayer->m_CharInfo.nHP );
		DrawString( m_nPosX + FRAME_TO_HP_MARGINE_X, iPosY, szBuff, STRING_COLOR );

		// ATBQ[W`
		m_AtbGauge[iCnt].Render();

		nCounter ++;
	}
}
