//=============================================================================
// SoundManager.cpp
//=============================================================================
#include "Stdinc.h"
#include "SoundManager.h"

typedef struct {
	int nID;
	const char *lpzFileName;
	int nLoopPos;
}stSoundFileTable;

stSoundFileTable BGM_FILE_TBL [] =
{
	{ BGM_ID_FOREST,		BGM_DIR "\\forest.mp3"	  ,	    0	},	// X
	{ BGM_ID_BATTLE,		BGM_DIR "\\battle3.mp3"	  ,	    0	},	// 퓬
	{ BGM_ID_BATTLE_WIN,	BGM_DIR "\\battle_win.mp3",	 5170	},	// 퓬
};

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CSoundManager::CSoundManager(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CSoundManager::~CSoundManager(void)
{
}
//-----------------------------------------------------------------------------
// Initialize
//-----------------------------------------------------------------------------
BOOL CSoundManager::Initialize( void )
{
	return TRUE;
}

//-----------------------------------------------------------------------------
// Finalize
//-----------------------------------------------------------------------------
void CSoundManager::Finalize( void )
{
	m_mapBGMHandle.clear();
	InitSoundMem();
}
//-----------------------------------------------------------------------------
// GetSoundFileName
//-----------------------------------------------------------------------------
const char *CSoundManager::GetSoundFileName( int nID )
{
	for ( int iCnt = 0; iCnt < sizeof(BGM_FILE_TBL) / sizeof(BGM_FILE_TBL[0]); iCnt ++ )
	{
		if ( BGM_FILE_TBL[iCnt].nID == nID )
			return BGM_FILE_TBL[iCnt].lpzFileName;
	}
	return NULL;
}
//-----------------------------------------------------------------------------
// GetSoundLoopPos
//-----------------------------------------------------------------------------
int CSoundManager::GetSoundLoopPos( int nID )
{
	for ( int iCnt = 0; iCnt < sizeof(BGM_FILE_TBL) / sizeof(BGM_FILE_TBL[0]); iCnt ++ )
	{
		if ( BGM_FILE_TBL[iCnt].nID == nID )
			return BGM_FILE_TBL[iCnt].nLoopPos;
	}
	return 0;
}
//-----------------------------------------------------------------------------
// ɓǂݍ
//-----------------------------------------------------------------------------
int CSoundManager::LoadMemory( int nID )
{
	int nHandle = LoadSoundMem( GetSoundFileName(nID) );
	if ( nHandle == DX_FAILED )
	{
		CSysUtil::Msg( "TEhǂݍݎs ID : %d [%s]", nID, GetSoundFileName(nID));
	}
	m_mapBGMHandle.insert( std::pair<int, int>( nID, nHandle ));

	return nHandle;
}
//-----------------------------------------------------------------------------
// PlayBGM
//-----------------------------------------------------------------------------
void CSoundManager::PlayBGM( int nID, BOOL nTopPositionFlag )
{
	printf("BGMĐ [%d] ߂[%d]\n", nID, nTopPositionFlag);
	using namespace std;

	int nHandle;
	map<int, int>::iterator itlMap;
	itlMap = m_mapBGMHandle.find( nID );
	if ( itlMap == m_mapBGMHandle.end() )
		return;


	nHandle = itlMap->second;

	StopAllBGM();

	int nLoopTime = GetSoundLoopPos( nID );

	if ( nLoopTime != NO_LOOP )
	{	// [vĐ
		SetLoopPosSoundMem( nLoopTime, nHandle );
		PlaySoundMem( nHandle, DX_PLAYTYPE_LOOP, nTopPositionFlag );
	}
	else
	{	// BGMĐ
		PlaySoundMem( nHandle, DX_PLAYTYPE_BACK );
	}

}

//-----------------------------------------------------------------------------
// StopAllBGM
//-----------------------------------------------------------------------------
void CSoundManager::StopAllBGM( void )
{
	using namespace std;

	int nHandle;
	map<int, int>::iterator itlMap;

	itlMap = m_mapBGMHandle.begin();
	while ( itlMap != m_mapBGMHandle.end() )
	{
		nHandle = itlMap->second;
		if ( CheckSoundMem( nHandle ) == 1 )
		{
			StopSoundMem( nHandle );
		}

		itlMap ++;
	}

}
